﻿-- ========================================================================
-- Author:			www.devart.com
-- Create date:	2010-08-09
-- Description:	Example Database for Devart dbForge blog
-- ========================================================================

CREATE DATABASE devart_dbforge_mysql;
USE devart_dbforge_mysql;
CREATE TABLE dept(
  DeptNo INT NOT NULL,
  DName VARCHAR(20),
  Loc VARCHAR(20),
  PRIMARY KEY (DeptNo)
) ENGINE = INNODB
;
CREATE TABLE emp(
  EmpNo INT NOT NULL,
  EName VARCHAR(10),
  Job VARCHAR(9),
  MGR INT,
  DeptNo INT,
  CONSTRAINT emp_dept_fk
  FOREIGN KEY (DeptNo)
  REFERENCES dept (DeptNo),
  PRIMARY KEY (EmpNo)
) ENGINE = INNODB
;
CREATE TABLE sal(
  ID INT NOT NULL AUTO_INCREMENT PRIMARY KEY,
  EmpNo INT NOT NULL,
  SalDate DATE,
  SalAmount FLOAT,
  Comm FLOAT,
  CONSTRAINT sal_emp_fk FOREIGN KEY (EmpNo)
  REFERENCES emp (EmpNo)
) ENGINE = INNODB
;
INSERT INTO dept VALUES
  (10, 'Human Resources', 'New York'),
  (20, 'Accounting', 'Chicago'),
  (30, 'Sales', 'Dallas')
;
INSERT INTO emp VALUES
  (9369, 'Ward', 'Salesman', 9566, 30),
  (9499, 'Allen', 'Clerk', 9698, 20),
  (9521, 'Smith', 'Salesman', 9698, 30),
  (9566, 'Martin', 'Manager', 9839, 20),
  (9654, 'Jones', 'Salesman', 9698, 30),
  (9698, 'Blake', 'Manager', 9839, 30),
  (9839, 'King', 'President', NULL, 10)
;
INSERT INTO sal (EmpNo, SalDate, SalAmount, Comm) VALUES
  (9369, '2008-01-01', 1700, NULL),
  (9369, '2009-01-01', 1500, 100),
  (9521, '2008-01-01', 2080, 350),
  (9521, '2009-01-01', 1900, NULL),
  (9654, '2008-01-01', 1130, 200),
  (9654, '2009-01-01', 1750, 150),
  (9839, '2008-01-01', 2750, 180),
  (9839, '2009-01-01', 3290, 180),
  (9566, '2008-01-01', 2490, NULL),
  (9566, '2009-01-01', 1230, 300),
  (9499, '2008-01-01', 1230, 250),
  (9499, '2009-01-01', 2490, 110)
;
CREATE VIEW v_SumSalComm_2008 AS
SELECT
  Loc, SUM(SalAmount) SalSum, SUM(Comm) ComSum
FROM
  emp
  JOIN dept ON emp.DeptNo = dept.DeptNo
  JOIN sal ON emp.EmpNo = sal.EmpNo
WHERE
  YEAR(SalDate) = 2008
GROUP BY
  Loc
;
CREATE VIEW v_SumSalComm_2009 AS
SELECT
  Loc, SUM(SalAmount) SalSum, SUM(Comm) ComSum
FROM
  emp
  JOIN dept ON emp.DeptNo = dept.DeptNo
  JOIN sal ON emp.EmpNo = sal.EmpNo
WHERE
  YEAR(SalDate) = 2009
GROUP BY
  Loc
;
USE mysql;